--  C:\PROJETO_ISH\MULTILATERATION\MULTILATERATION_CONTROL.vhd
--  VHDL code created by Xilinx's StateCAD 9.1i
--  Thu Jun 28 22:26:07 2007

--  This VHDL code (for use with Xilinx XST) was generated using: 
--  binary encoded state assignment with structured code format.
--  Minimization is enabled,  implied else is enabled, 
--  and outputs are manually optimized.

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY MULTILATERATION_CONTROL IS
	PORT (CLK,div_factor_rdy,exps_rdy,nums_rdy,sclr,start,xy_rdy: IN std_logic;
		div_factor_start,exps_start,nums_start,rdy,xy_start : OUT std_logic);
END;

ARCHITECTURE BEHAVIOR OF MULTILATERATION_CONTROL IS
	SIGNAL sreg : std_logic_vector (2 DOWNTO 0);
	SIGNAL next_sreg : std_logic_vector (2 DOWNTO 0);
	CONSTANT EXPS_WAIT_ST : std_logic_vector (2 DOWNTO 0) :="111";
	CONSTANT IDLE_ST : std_logic_vector (2 DOWNTO 0) :="110";
	CONSTANT INIT_DIV_NUM_ST : std_logic_vector (2 DOWNTO 0) :="101";
	CONSTANT INIT_EXPS_ST : std_logic_vector (2 DOWNTO 0) :="100";
	CONSTANT INIT_XY_ST : std_logic_vector (2 DOWNTO 0) :="011";
	CONSTANT RDY_ST : std_logic_vector (2 DOWNTO 0) :="010";
	CONSTANT WAIT_DIV_NUM_ST : std_logic_vector (2 DOWNTO 0) :="001";
	CONSTANT WAIT_XY_ST : std_logic_vector (2 DOWNTO 0) :="000";

BEGIN
	PROCESS (CLK, next_sreg)
	BEGIN
		IF CLK='1' AND CLK'event THEN
			sreg <= next_sreg;
		END IF;
	END PROCESS;

	PROCESS (sreg,div_factor_rdy,exps_rdy,nums_rdy,sclr,start,xy_rdy)
	BEGIN
		div_factor_start <= '0'; exps_start <= '0'; nums_start <= '0'; rdy <= '0'; 
			xy_start <= '0'; 

		next_sreg<=EXPS_WAIT_ST;

		IF ( sclr='1' ) THEN
			next_sreg<=IDLE_ST;
			div_factor_start<='0';
			exps_start<='0';
			nums_start<='0';
			xy_start<='0';
			rdy<='0';
		ELSE
			CASE sreg IS
				WHEN EXPS_WAIT_ST =>
					div_factor_start<='0';
					exps_start<='0';
					nums_start<='0';
					rdy<='0';
					xy_start<='0';
					IF ( exps_rdy='1' ) THEN
						next_sreg<=INIT_DIV_NUM_ST;
					 ELSE
						next_sreg<=EXPS_WAIT_ST;
					END IF;
				WHEN IDLE_ST =>
					div_factor_start<='0';
					exps_start<='0';
					nums_start<='0';
					xy_start<='0';
					rdy<='0';
					IF ( start='1' ) THEN
						next_sreg<=INIT_EXPS_ST;
					 ELSE
						next_sreg<=IDLE_ST;
					END IF;
				WHEN INIT_DIV_NUM_ST =>
					exps_start<='0';
					rdy<='0';
					xy_start<='0';
					div_factor_start<='1';
					nums_start<='1';
					next_sreg<=WAIT_DIV_NUM_ST;
				WHEN INIT_EXPS_ST =>
					div_factor_start<='0';
					nums_start<='0';
					rdy<='0';
					xy_start<='0';
					exps_start<='1';
					next_sreg<=EXPS_WAIT_ST;
				WHEN INIT_XY_ST =>
					div_factor_start<='0';
					exps_start<='0';
					nums_start<='0';
					rdy<='0';
					xy_start<='1';
					next_sreg<=WAIT_XY_ST;
				WHEN RDY_ST =>
					div_factor_start<='0';
					exps_start<='0';
					nums_start<='0';
					xy_start<='0';
					rdy<='1';
					IF ( start='1' ) THEN
						next_sreg<=INIT_EXPS_ST;
					 ELSE
						next_sreg<=RDY_ST;
					END IF;
				WHEN WAIT_DIV_NUM_ST =>
					div_factor_start<='0';
					exps_start<='0';
					nums_start<='0';
					rdy<='0';
					xy_start<='0';
					IF ( div_factor_rdy='1' AND nums_rdy='1' ) THEN
						next_sreg<=INIT_XY_ST;
					 ELSE
						next_sreg<=WAIT_DIV_NUM_ST;
					END IF;
				WHEN WAIT_XY_ST =>
					div_factor_start<='0';
					exps_start<='0';
					nums_start<='0';
					rdy<='0';
					xy_start<='0';
					IF ( xy_rdy='1' ) THEN
						next_sreg<=RDY_ST;
					 ELSE
						next_sreg<=WAIT_XY_ST;
					END IF;
				WHEN OTHERS =>
			END CASE;
		END IF;
	END PROCESS;
END BEHAVIOR;
