--------------------------------------------------------------------------------
-- Copyright (c) 1995-2007 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 9.1.03i
--  \   \         Application : sch2vhdl
--  /   /         Filename : multilateration.vhf
-- /___/   /\     Timestamp : 07/14/2007 02:30:55
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: C:\Xilinx91i\bin\nt\sch2vhdl.exe -intstyle ise -family virtex4 -flat -suppress -w C:/xps/isha/pcores/multilateration_ip_v1_00_a/devl/projnav/multilateration.sch multilateration.vhf
--Design Name: multilateration
--Device: virtex4
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesis and simulted, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity multilateration is
   port ( A11   : in    std_logic_vector (31 downto 0); 
          A12   : in    std_logic_vector (31 downto 0); 
          A21   : in    std_logic_vector (31 downto 0); 
          A22   : in    std_logic_vector (31 downto 0); 
          A31   : in    std_logic_vector (31 downto 0); 
          A32   : in    std_logic_vector (31 downto 0); 
          B11   : in    std_logic_vector (31 downto 0); 
          B21   : in    std_logic_vector (31 downto 0); 
          B31   : in    std_logic_vector (31 downto 0); 
          CLK   : in    std_logic; 
          RESET : in    std_logic; 
          start : in    std_logic; 
          rdy   : out   std_logic; 
          x     : out   std_logic_vector (31 downto 0); 
          y     : out   std_logic_vector (31 downto 0));
end multilateration;

architecture BEHAVIORAL of multilateration is
   signal XLXN_1  : std_logic_vector (31 downto 0);
   signal XLXN_2  : std_logic_vector (31 downto 0);
   signal XLXN_3  : std_logic_vector (31 downto 0);
   signal XLXN_4  : std_logic_vector (31 downto 0);
   signal XLXN_5  : std_logic_vector (31 downto 0);
   signal XLXN_14 : std_logic_vector (31 downto 0);
   signal XLXN_22 : std_logic;
   signal XLXN_23 : std_logic;
   signal XLXN_24 : std_logic;
   signal XLXN_41 : std_logic;
   signal XLXN_42 : std_logic;
   signal XLXN_43 : std_logic;
   signal XLXN_50 : std_logic;
   signal XLXN_58 : std_logic;
   component MULTILATERATION_CONTROL
      port ( CLK              : in    std_logic; 
             div_factor_rdy   : in    std_logic; 
             exps_rdy         : in    std_logic; 
             nums_rdy         : in    std_logic; 
             sclr             : in    std_logic; 
             start            : in    std_logic; 
             xy_rdy           : in    std_logic; 
             div_factor_start : out   std_logic; 
             exps_start       : out   std_logic; 
             nums_start       : out   std_logic; 
             rdy              : out   std_logic; 
             xy_start         : out   std_logic);
   end component;
   
   component div_factor_calc
      port ( EXP1      : in    std_logic_vector (31 downto 0); 
             EXP2      : in    std_logic_vector (31 downto 0); 
             EXP3      : in    std_logic_vector (31 downto 0); 
             CLK       : in    std_logic; 
             RESET     : in    std_logic; 
             START     : in    std_logic; 
             DIVFACTOR : out   std_logic_vector (31 downto 0); 
             RDY       : out   std_logic);
   end component;
   
   component exps_calc
      port ( a11   : in    std_logic_vector (31 downto 0); 
             a12   : in    std_logic_vector (31 downto 0); 
             a21   : in    std_logic_vector (31 downto 0); 
             a22   : in    std_logic_vector (31 downto 0); 
             a31   : in    std_logic_vector (31 downto 0); 
             a32   : in    std_logic_vector (31 downto 0); 
             reset : in    std_logic; 
             clk   : in    std_logic; 
             start : in    std_logic; 
             exp1  : out   std_logic_vector (31 downto 0); 
             exp3  : out   std_logic_vector (31 downto 0); 
             exp2  : out   std_logic_vector (31 downto 0); 
             rdy   : out   std_logic);
   end component;
   
   component numerators_calc
      port ( a11   : in    std_logic_vector (31 downto 0); 
             a12   : in    std_logic_vector (31 downto 0); 
             a21   : in    std_logic_vector (31 downto 0); 
             a22   : in    std_logic_vector (31 downto 0); 
             a31   : in    std_logic_vector (31 downto 0); 
             a32   : in    std_logic_vector (31 downto 0); 
             b11   : in    std_logic_vector (31 downto 0); 
             b21   : in    std_logic_vector (31 downto 0); 
             b31   : in    std_logic_vector (31 downto 0); 
             exp2  : in    std_logic_vector (31 downto 0); 
             exp3  : in    std_logic_vector (31 downto 0); 
             exp1  : in    std_logic_vector (31 downto 0); 
             clk   : in    std_logic; 
             reset : in    std_logic; 
             START : in    std_logic; 
             num_x : out   std_logic_vector (31 downto 0); 
             num_y : out   std_logic_vector (31 downto 0); 
             rdy   : out   std_logic);
   end component;
   
   component xy_calc
      port ( clk        : in    std_logic; 
             div_factor : in    std_logic_vector (31 downto 0); 
             reset      : in    std_logic; 
             num_x      : in    std_logic_vector (31 downto 0); 
             num_y      : in    std_logic_vector (31 downto 0); 
             start      : in    std_logic; 
             x          : out   std_logic_vector (31 downto 0); 
             y          : out   std_logic_vector (31 downto 0); 
             rdy        : out   std_logic);
   end component;
   
begin
   control : MULTILATERATION_CONTROL
      port map (CLK=>CLK,
                div_factor_rdy=>XLXN_24,
                exps_rdy=>XLXN_22,
                nums_rdy=>XLXN_23,
                sclr=>RESET,
                start=>start,
                xy_rdy=>XLXN_50,
                div_factor_start=>XLXN_42,
                exps_start=>XLXN_58,
                nums_start=>XLXN_41,
                rdy=>rdy,
                xy_start=>XLXN_43);
   
   divfaccalc_1 : div_factor_calc
      port map (CLK=>CLK,
                EXP1(31 downto 0)=>XLXN_1(31 downto 0),
                EXP2(31 downto 0)=>XLXN_2(31 downto 0),
                EXP3(31 downto 0)=>XLXN_3(31 downto 0),
                RESET=>RESET,
                START=>XLXN_42,
                DIVFACTOR(31 downto 0)=>XLXN_14(31 downto 0),
                RDY=>XLXN_24);
   
   exps_calc_1 : exps_calc
      port map (a11(31 downto 0)=>A11(31 downto 0),
                a12(31 downto 0)=>A12(31 downto 0),
                a21(31 downto 0)=>A21(31 downto 0),
                a22(31 downto 0)=>A22(31 downto 0),
                a31(31 downto 0)=>A31(31 downto 0),
                a32(31 downto 0)=>A32(31 downto 0),
                clk=>CLK,
                reset=>RESET,
                start=>XLXN_58,
                exp1(31 downto 0)=>XLXN_1(31 downto 0),
                exp2(31 downto 0)=>XLXN_2(31 downto 0),
                exp3(31 downto 0)=>XLXN_3(31 downto 0),
                rdy=>XLXN_22);
   
   num_calc_1 : numerators_calc
      port map (a11(31 downto 0)=>A11(31 downto 0),
                a12(31 downto 0)=>A12(31 downto 0),
                a21(31 downto 0)=>A21(31 downto 0),
                a22(31 downto 0)=>A22(31 downto 0),
                a31(31 downto 0)=>A31(31 downto 0),
                a32(31 downto 0)=>A32(31 downto 0),
                b11(31 downto 0)=>B11(31 downto 0),
                b21(31 downto 0)=>B21(31 downto 0),
                b31(31 downto 0)=>B31(31 downto 0),
                clk=>CLK,
                exp1(31 downto 0)=>XLXN_1(31 downto 0),
                exp2(31 downto 0)=>XLXN_2(31 downto 0),
                exp3(31 downto 0)=>XLXN_3(31 downto 0),
                reset=>RESET,
                START=>XLXN_41,
                num_x(31 downto 0)=>XLXN_4(31 downto 0),
                num_y(31 downto 0)=>XLXN_5(31 downto 0),
                rdy=>XLXN_23);
   
   xy_calc_1 : xy_calc
      port map (clk=>CLK,
                div_factor(31 downto 0)=>XLXN_14(31 downto 0),
                num_x(31 downto 0)=>XLXN_4(31 downto 0),
                num_y(31 downto 0)=>XLXN_5(31 downto 0),
                reset=>RESET,
                start=>XLXN_43,
                rdy=>XLXN_50,
                x(31 downto 0)=>x(31 downto 0),
                y(31 downto 0)=>y(31 downto 0));
   
end BEHAVIORAL;


