--------------------------------------------------------------------------------
-- Copyright (c) 1995-2007 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 9.1.03i
--  \   \         Application : sch2vhdl
--  /   /         Filename : numerators_calc.vhf
-- /___/   /\     Timestamp : 07/14/2007 02:30:57
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: C:\Xilinx91i\bin\nt\sch2vhdl.exe -intstyle ise -family virtex4 -flat -suppress -w C:/xps/isha/pcores/multilateration_ip_v1_00_a/devl/projnav/numerators_calc.sch numerators_calc.vhf
--Design Name: numerators_calc
--Device: virtex4
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesis and simulted, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity numerators_calc is
   port ( a11   : in    std_logic_vector (31 downto 0); 
          a12   : in    std_logic_vector (31 downto 0); 
          a21   : in    std_logic_vector (31 downto 0); 
          a22   : in    std_logic_vector (31 downto 0); 
          a31   : in    std_logic_vector (31 downto 0); 
          a32   : in    std_logic_vector (31 downto 0); 
          b11   : in    std_logic_vector (31 downto 0); 
          b21   : in    std_logic_vector (31 downto 0); 
          b31   : in    std_logic_vector (31 downto 0); 
          clk   : in    std_logic; 
          exp1  : in    std_logic_vector (31 downto 0); 
          exp2  : in    std_logic_vector (31 downto 0); 
          exp3  : in    std_logic_vector (31 downto 0); 
          reset : in    std_logic; 
          START : in    std_logic; 
          num_x : out   std_logic_vector (31 downto 0); 
          num_y : out   std_logic_vector (31 downto 0); 
          rdy   : out   std_logic);
end numerators_calc;

architecture BEHAVIORAL of numerators_calc is
   signal ADD_A       : std_logic_vector (31 downto 0);
   signal ADD_B       : std_logic_vector (31 downto 0);
   signal ADD_ND      : std_logic;
   signal ADD_RDY     : std_logic;
   signal ADD_RESULT  : std_logic_vector (31 downto 0);
   signal MULT_A      : std_logic_vector (31 downto 0);
   signal MULT_B      : std_logic_vector (31 downto 0);
   signal MULT_ND     : std_logic;
   signal MULT_RDY    : std_logic;
   signal MULT_RESULT : std_logic_vector (31 downto 0);
   signal XLXN_110    : std_logic_vector (31 downto 0);
   signal XLXN_112    : std_logic_vector (31 downto 0);
   signal XLXN_169    : std_logic_vector (31 downto 0);
   signal XLXN_174    : std_logic_vector (31 downto 0);
   signal XLXN_181    : std_logic_vector (1 downto 0);
   signal XLXN_183    : std_logic_vector (1 downto 0);
   signal XLXN_184    : std_logic_vector (1 downto 0);
   signal XLXN_185    : std_logic_vector (3 downto 0);
   signal XLXN_202    : std_logic;
   signal XLXN_203    : std_logic;
   signal XLXN_204    : std_logic;
   signal XLXN_205    : std_logic;
   component mux32_3
      port ( a        : in    std_logic_vector (31 downto 0); 
             b        : in    std_logic_vector (31 downto 0); 
             c        : in    std_logic_vector (31 downto 0); 
             selector : in    std_logic_vector (1 downto 0); 
             selected : out   std_logic_vector (31 downto 0));
   end component;
   
   component reg32
      port ( LOAD   : in    std_logic; 
             RESET  : in    std_logic; 
             CLK    : in    std_logic; 
             INPUT  : in    std_logic_vector (31 downto 0); 
             OUTPUT : out   std_logic_vector (31 downto 0));
   end component;
   
   component add_fp
      port ( a             : in    std_logic_vector (31 downto 0); 
             b             : in    std_logic_vector (31 downto 0); 
             operation_nd  : in    std_logic; 
             operation_rfd : out   std_logic; 
             sclr          : in    std_logic; 
             clk           : in    std_logic; 
             result        : out   std_logic_vector (31 downto 0); 
             rdy           : out   std_logic);
   end component;
   
   component NUMERATORS_CALC_CONTROL
      port ( CLK            : in    std_logic; 
             add_rdy        : in    std_logic; 
             mult_rdy       : in    std_logic; 
             SCLR           : in    std_logic; 
             start          : in    std_logic; 
             add_nd         : out   std_logic; 
             add_x_tmp_load : out   std_logic; 
             add_y_tmp_load : out   std_logic; 
             mult_nd        : out   std_logic; 
             num_x_load     : out   std_logic; 
             num_y_load     : out   std_logic; 
             rdy            : out   std_logic; 
             add_a_mux_sel  : out   std_logic_vector (1 downto 0); 
             add_b_mux_sel  : out   std_logic_vector (1 downto 0); 
             mult_a_mux_sl  : out   std_logic_vector (1 downto 0); 
             mult_b_mux_sel : out   std_logic_vector (3 downto 0));
   end component;
   
   component mux32_4
      port ( a        : in    std_logic_vector (31 downto 0); 
             b        : in    std_logic_vector (31 downto 0); 
             c        : in    std_logic_vector (31 downto 0); 
             d        : in    std_logic_vector (31 downto 0); 
             selector : in    std_logic_vector (1 downto 0); 
             selected : out   std_logic_vector (31 downto 0));
   end component;
   
   component mux32_9
      port ( in0      : in    std_logic_vector (31 downto 0); 
             in1      : in    std_logic_vector (31 downto 0); 
             in2      : in    std_logic_vector (31 downto 0); 
             in3      : in    std_logic_vector (31 downto 0); 
             in4      : in    std_logic_vector (31 downto 0); 
             in5      : in    std_logic_vector (31 downto 0); 
             in6      : in    std_logic_vector (31 downto 0); 
             in7      : in    std_logic_vector (31 downto 0); 
             in8      : in    std_logic_vector (31 downto 0); 
             selector : in    std_logic_vector (3 downto 0); 
             selected : out   std_logic_vector (31 downto 0));
   end component;
   
   component mult_fp
      port ( a             : in    std_logic_vector (31 downto 0); 
             b             : in    std_logic_vector (31 downto 0); 
             operation_nd  : in    std_logic; 
             operation_rfd : out   std_logic; 
             sclr          : in    std_logic; 
             clk           : in    std_logic; 
             result        : out   std_logic_vector (31 downto 0); 
             rdy           : out   std_logic);
   end component;
   
begin
   add_a_mux : mux32_3
      port map (a(31 downto 0)=>XLXN_174(31 downto 0),
                b(31 downto 0)=>XLXN_110(31 downto 0),
                c(31 downto 0)=>XLXN_112(31 downto 0),
                selector(1 downto 0)=>XLXN_184(1 downto 0),
                selected(31 downto 0)=>ADD_A(31 downto 0));
   
   add_b_mux : mux32_3
      port map (a(31 downto 0)=>MULT_RESULT(31 downto 0),
                b(31 downto 0)=>XLXN_169(31 downto 0),
                c(31 downto 0)=>XLXN_174(31 downto 0),
                selector(1 downto 0)=>XLXN_183(1 downto 0),
                selected(31 downto 0)=>ADD_B(31 downto 0));
   
   add_res_reg : reg32
      port map (CLK=>clk,
                INPUT(31 downto 0)=>ADD_RESULT(31 downto 0),
                LOAD=>ADD_RDY,
                RESET=>reset,
                OUTPUT(31 downto 0)=>XLXN_169(31 downto 0));
   
   add_x_tmp : reg32
      port map (CLK=>clk,
                INPUT(31 downto 0)=>XLXN_174(31 downto 0),
                LOAD=>XLXN_204,
                RESET=>reset,
                OUTPUT(31 downto 0)=>XLXN_110(31 downto 0));
   
   add_y_tmp : reg32
      port map (CLK=>clk,
                INPUT(31 downto 0)=>XLXN_174(31 downto 0),
                LOAD=>XLXN_205,
                RESET=>reset,
                OUTPUT(31 downto 0)=>XLXN_112(31 downto 0));
   
   add1 : add_fp
      port map (a(31 downto 0)=>ADD_A(31 downto 0),
                b(31 downto 0)=>ADD_B(31 downto 0),
                clk=>clk,
                operation_nd=>ADD_ND,
                sclr=>reset,
                operation_rfd=>open,
                rdy=>ADD_RDY,
                result(31 downto 0)=>ADD_RESULT(31 downto 0));
   
   control : NUMERATORS_CALC_CONTROL
      port map (add_rdy=>ADD_RDY,
                CLK=>clk,
                mult_rdy=>MULT_RDY,
                SCLR=>reset,
                start=>START,
                add_a_mux_sel(1 downto 0)=>XLXN_184(1 downto 0),
                add_b_mux_sel(1 downto 0)=>XLXN_183(1 downto 0),
                add_nd=>ADD_ND,
                add_x_tmp_load=>XLXN_204,
                add_y_tmp_load=>XLXN_205,
                mult_a_mux_sl(1 downto 0)=>XLXN_181(1 downto 0),
                mult_b_mux_sel(3 downto 0)=>XLXN_185(3 downto 0),
                mult_nd=>MULT_ND,
                num_x_load=>XLXN_202,
                num_y_load=>XLXN_203,
                rdy=>rdy);
   
   mult_a_mux : mux32_4
      port map (a(31 downto 0)=>exp1(31 downto 0),
                b(31 downto 0)=>exp2(31 downto 0),
                c(31 downto 0)=>exp3(31 downto 0),
                d(31 downto 0)=>XLXN_169(31 downto 0),
                selector(1 downto 0)=>XLXN_181(1 downto 0),
                selected(31 downto 0)=>MULT_A(31 downto 0));
   
   mult_b_mux : mux32_9
      port map (in0(31 downto 0)=>a11(31 downto 0),
                in1(31 downto 0)=>a12(31 downto 0),
                in2(31 downto 0)=>a21(31 downto 0),
                in3(31 downto 0)=>a22(31 downto 0),
                in4(31 downto 0)=>a31(31 downto 0),
                in5(31 downto 0)=>a32(31 downto 0),
                in6(31 downto 0)=>b11(31 downto 0),
                in7(31 downto 0)=>b21(31 downto 0),
                in8(31 downto 0)=>b31(31 downto 0),
                selector(3 downto 0)=>XLXN_185(3 downto 0),
                selected(31 downto 0)=>MULT_B(31 downto 0));
   
   mult_res_reg : reg32
      port map (CLK=>clk,
                INPUT(31 downto 0)=>MULT_RESULT(31 downto 0),
                LOAD=>MULT_RDY,
                RESET=>reset,
                OUTPUT(31 downto 0)=>XLXN_174(31 downto 0));
   
   mult1 : mult_fp
      port map (a(31 downto 0)=>MULT_A(31 downto 0),
                b(31 downto 0)=>MULT_B(31 downto 0),
                clk=>clk,
                operation_nd=>MULT_ND,
                sclr=>reset,
                operation_rfd=>open,
                rdy=>MULT_RDY,
                result(31 downto 0)=>MULT_RESULT(31 downto 0));
   
   num_x_reg : reg32
      port map (CLK=>clk,
                INPUT(31 downto 0)=>XLXN_169(31 downto 0),
                LOAD=>XLXN_202,
                RESET=>reset,
                OUTPUT(31 downto 0)=>num_x(31 downto 0));
   
   num_y_reg : reg32
      port map (CLK=>clk,
                INPUT(31 downto 0)=>XLXN_169(31 downto 0),
                LOAD=>XLXN_203,
                RESET=>reset,
                OUTPUT(31 downto 0)=>num_y(31 downto 0));
   
end BEHAVIORAL;


