----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:59:06 06/12/2007 
-- Design Name: 
-- Module Name:    router_6_2 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity router_6_2 is
    Port ( a11 : in  STD_LOGIC_VECTOR (31 downto 0);
           a12 : in  STD_LOGIC_VECTOR (31 downto 0);
           a21 : in  STD_LOGIC_VECTOR (31 downto 0);
           a22 : in  STD_LOGIC_VECTOR (31 downto 0);
           a31 : in  STD_LOGIC_VECTOR (31 downto 0);
           a32 : in  STD_LOGIC_VECTOR (31 downto 0);
           selector : in  STD_LOGIC_VECTOR (3 downto 0);
           a : out  STD_LOGIC_VECTOR (31 downto 0);
           b : out  STD_LOGIC_VECTOR (31 downto 0));
end router_6_2;

architecture Behavioral of router_6_2 is
	CONSTANT A11_A11 : std_logic_vector (3 DOWNTO 0) :="0000";
	CONSTANT A21_A21 : std_logic_vector (3 DOWNTO 0) :="0001";
	CONSTANT A12_A12 : std_logic_vector (3 DOWNTO 0) :="0010";
	CONSTANT A22_A22 : std_logic_vector (3 DOWNTO 0) :="0011";
	CONSTANT A11_A12 : std_logic_vector (3 DOWNTO 0) :="0100";
	CONSTANT A21_A22 : std_logic_vector (3 DOWNTO 0) :="0101";
	CONSTANT A31_A31 : std_logic_vector (3 DOWNTO 0) :="0110";
	CONSTANT A32_A32 : std_logic_vector (3 DOWNTO 0) :="0111";
	CONSTANT A31_A32 : std_logic_vector (3 DOWNTO 0) :="1000";
	
begin

	PROCESS (selector, a11, a12, a21, a22, a31, a32)
	BEGIN
		case selector is 
			when A11_A11 =>
				a <= a11;
				b <= a11;
			when A12_A12 =>
				a <= a12;
				b <= a12;
			when A11_A12 =>
				a <= a11;
				b <= a12;
			when A21_A21 =>
				a <= a21;
				b <= a21;
			when A22_A22 =>
				a <= a22;
				b <= a22;
			when A21_A22 =>
				a <= a21;
				b <= a22;
			when A31_A31 =>
				a <= a31;
				b <= a31;
			when A32_A32 =>
				a <= a32;
				b <= a32;
			when A31_A32 =>
				a <= a31;
				b <= a32;
			when others =>
				-- writes 0xffff ffff (NaN)
				a <= "11111111111111111111111111111111";
				b <= "11111111111111111111111111111111";
		end case;		
	END PROCESS;

end Behavioral;

