--  C:\PROJETO_ISH\MULTILATERATION\XY_CALC_CONTROL.vhd
--  VHDL code created by Xilinx's StateCAD 9.1i
--  Thu Jun 28 22:25:18 2007

--  This VHDL code (for use with Xilinx XST) was generated using: 
--  binary encoded state assignment with structured code format.
--  Minimization is enabled,  implied else is enabled, 
--  and outputs are manually optimized.

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY XY_CALC_CONTROL IS
	PORT (CLK,div_rdy,sclr,start: IN std_logic;
		div_a_mux_sel,div_nd,rdy,x_reg_load,y_reg_load : OUT std_logic);
END;

ARCHITECTURE BEHAVIOR OF XY_CALC_CONTROL IS
	SIGNAL sreg : std_logic_vector (2 DOWNTO 0);
	SIGNAL next_sreg : std_logic_vector (2 DOWNTO 0);
	CONSTANT IDLE_ST : std_logic_vector (2 DOWNTO 0) :="000";
	CONSTANT RDY_ST : std_logic_vector (2 DOWNTO 0) :="001";
	CONSTANT X_CALC_ST : std_logic_vector (2 DOWNTO 0) :="010";
	CONSTANT X_LOAD_ST : std_logic_vector (2 DOWNTO 0) :="011";
	CONSTANT X_WAIT_ST : std_logic_vector (2 DOWNTO 0) :="100";
	CONSTANT Y_CALC_ST : std_logic_vector (2 DOWNTO 0) :="101";
	CONSTANT Y_LOAD_ST : std_logic_vector (2 DOWNTO 0) :="110";

BEGIN
	PROCESS (CLK, next_sreg)
	BEGIN
		IF CLK='1' AND CLK'event THEN
			sreg <= next_sreg;
		END IF;
	END PROCESS;

	PROCESS (sreg,div_rdy,sclr,start)
	BEGIN
		div_a_mux_sel <= '0'; div_nd <= '0'; rdy <= '0'; x_reg_load <= '0'; 
			y_reg_load <= '0'; 

		next_sreg<=IDLE_ST;

		IF ( sclr='1' ) THEN
			next_sreg<=IDLE_ST;
			y_reg_load<='0';
			x_reg_load<='0';
			div_nd<='0';
			div_a_mux_sel<='0';
			rdy<='0';
		ELSE
			CASE sreg IS
				WHEN IDLE_ST =>
					y_reg_load<='0';
					x_reg_load<='0';
					div_nd<='0';
					div_a_mux_sel<='0';
					rdy<='0';
					IF ( start='1' ) THEN
						next_sreg<=X_CALC_ST;
					 ELSE
						next_sreg<=IDLE_ST;
					END IF;
				WHEN RDY_ST =>
					y_reg_load<='0';
					x_reg_load<='0';
					div_nd<='0';
					div_a_mux_sel<='0';
					rdy<='1';
					IF ( start='1' ) THEN
						next_sreg<=X_CALC_ST;
					 ELSE
						next_sreg<=RDY_ST;
					END IF;
				WHEN X_CALC_ST =>
					y_reg_load<='0';
					x_reg_load<='0';
					rdy<='0';
					div_a_mux_sel<='0';
					div_nd<='1';
					next_sreg<=Y_CALC_ST;
				WHEN X_LOAD_ST =>
					y_reg_load<='0';
					rdy<='0';
					div_nd<='0';
					div_a_mux_sel<='0';
					x_reg_load<='1';
					next_sreg<=Y_LOAD_ST;
				WHEN X_WAIT_ST =>
					y_reg_load<='0';
					x_reg_load<='0';
					rdy<='0';
					div_nd<='0';
					div_a_mux_sel<='0';
					IF ( div_rdy='1' ) THEN
						next_sreg<=X_LOAD_ST;
					 ELSE
						next_sreg<=X_WAIT_ST;
					END IF;
				WHEN Y_CALC_ST =>
					y_reg_load<='0';
					x_reg_load<='0';
					rdy<='0';
					div_a_mux_sel<='1';
					div_nd<='1';
					next_sreg<=X_WAIT_ST;
				WHEN Y_LOAD_ST =>
					x_reg_load<='0';
					rdy<='0';
					div_nd<='0';
					div_a_mux_sel<='0';
					y_reg_load<='1';
					next_sreg<=RDY_ST;
				WHEN OTHERS =>
			END CASE;
		END IF;
	END PROCESS;
END BEHAVIOR;
