--------------------------------------------------------------------------------
-- Copyright (c) 1995-2007 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 9.1.03i
--  \   \         Application : sch2vhdl
--  /   /         Filename : div_factor_calc.vhf
-- /___/   /\     Timestamp : 07/14/2007 00:33:52
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: C:\Xilinx91i\bin\nt\sch2vhdl.exe -intstyle ise -family virtex4 -flat -suppress -w C:/xps/isha/pcores/multilateration_ip_v1_00_a/devl/projnav/div_factor_calc.sch div_factor_calc.vhf
--Design Name: div_factor_calc
--Device: virtex4
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesis and simulted, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity div_factor_calc is
   port ( CLK       : in    std_logic; 
          EXP1      : in    std_logic_vector (31 downto 0); 
          EXP2      : in    std_logic_vector (31 downto 0); 
          EXP3      : in    std_logic_vector (31 downto 0); 
          RESET     : in    std_logic; 
          START     : in    std_logic; 
          DIVFACTOR : out   std_logic_vector (31 downto 0); 
          RDY       : out   std_logic);
end div_factor_calc;

architecture BEHAVIORAL of div_factor_calc is
   signal MUL1_RDY  : std_logic;
   signal sub_nd    : std_logic;
   signal sub1_rdy  : std_logic;
   signal XLXN_1    : std_logic_vector (31 downto 0);
   signal XLXN_2    : std_logic_vector (31 downto 0);
   signal XLXN_8    : std_logic_vector (31 downto 0);
   signal XLXN_10   : std_logic_vector (31 downto 0);
   signal XLXN_11   : std_logic_vector (31 downto 0);
   signal XLXN_24   : std_logic_vector (31 downto 0);
   signal XLXN_69   : std_logic;
   signal XLXN_72   : std_logic;
   signal XLXN_75   : std_logic;
   signal XLXN_86   : std_logic_vector (31 downto 0);
   signal XLXN_93   : std_logic;
   component DIV_FACTOR_CONTROL
      port ( CLK           : in    std_logic; 
             MULT1_RDY     : in    std_logic; 
             SCLR          : in    std_logic; 
             START         : in    std_logic; 
             SUB1_RDY      : in    std_logic; 
             LOAD_PART_REG : out   std_logic; 
             LOAD_REGS     : out   std_logic; 
             MULT1_ND      : out   std_logic; 
             MUX_SEL       : out   std_logic; 
             RDY           : out   std_logic; 
             SUB_ND        : out   std_logic);
   end component;
   
   component mux32_2
      port ( SELECTOR : in    std_logic; 
             A        : in    std_logic_vector (31 downto 0); 
             B        : in    std_logic_vector (31 downto 0); 
             OUTPUT   : out   std_logic_vector (31 downto 0));
   end component;
   
   component mult_fp
      port ( a             : in    std_logic_vector (31 downto 0); 
             b             : in    std_logic_vector (31 downto 0); 
             operation_nd  : in    std_logic; 
             operation_rfd : out   std_logic; 
             sclr          : in    std_logic; 
             clk           : in    std_logic; 
             result        : out   std_logic_vector (31 downto 0); 
             rdy           : out   std_logic);
   end component;
   
   component reg32
      port ( LOAD   : in    std_logic; 
             RESET  : in    std_logic; 
             CLK    : in    std_logic; 
             INPUT  : in    std_logic_vector (31 downto 0); 
             OUTPUT : out   std_logic_vector (31 downto 0));
   end component;
   
   component sub_fp
      port ( a             : in    std_logic_vector (31 downto 0); 
             b             : in    std_logic_vector (31 downto 0); 
             operation_nd  : in    std_logic; 
             operation_rfd : out   std_logic; 
             sclr          : in    std_logic; 
             clk           : in    std_logic; 
             result        : out   std_logic_vector (31 downto 0); 
             rdy           : out   std_logic);
   end component;
   
begin
   CTRL : DIV_FACTOR_CONTROL
      port map (CLK=>CLK,
                MULT1_RDY=>MUL1_RDY,
                SCLR=>RESET,
                START=>START,
                SUB1_RDY=>sub1_rdy,
                LOAD_PART_REG=>XLXN_93,
                LOAD_REGS=>XLXN_69,
                MULT1_ND=>XLXN_72,
                MUX_SEL=>XLXN_75,
                RDY=>RDY,
                SUB_ND=>sub_nd);
   
   mult_a_mux : mux32_2
      port map (A(31 downto 0)=>XLXN_1(31 downto 0),
                B(31 downto 0)=>XLXN_8(31 downto 0),
                SELECTOR=>XLXN_75,
                OUTPUT(31 downto 0)=>XLXN_10(31 downto 0));
   
   mult_b_mux : mux32_2
      port map (A(31 downto 0)=>XLXN_2(31 downto 0),
                B(31 downto 0)=>XLXN_8(31 downto 0),
                SELECTOR=>XLXN_75,
                OUTPUT(31 downto 0)=>XLXN_11(31 downto 0));
   
   mult_1 : mult_fp
      port map (a(31 downto 0)=>XLXN_10(31 downto 0),
                b(31 downto 0)=>XLXN_11(31 downto 0),
                clk=>CLK,
                operation_nd=>XLXN_72,
                sclr=>RESET,
                operation_rfd=>open,
                rdy=>MUL1_RDY,
                result(31 downto 0)=>XLXN_24(31 downto 0));
   
   PARTIAL_REG : reg32
      port map (CLK=>CLK,
                INPUT(31 downto 0)=>XLXN_24(31 downto 0),
                LOAD=>XLXN_93,
                RESET=>RESET,
                OUTPUT(31 downto 0)=>XLXN_86(31 downto 0));
   
   REG1 : reg32
      port map (CLK=>CLK,
                INPUT(31 downto 0)=>EXP1(31 downto 0),
                LOAD=>XLXN_69,
                RESET=>RESET,
                OUTPUT(31 downto 0)=>XLXN_1(31 downto 0));
   
   REG2 : reg32
      port map (CLK=>CLK,
                INPUT(31 downto 0)=>EXP2(31 downto 0),
                LOAD=>XLXN_69,
                RESET=>RESET,
                OUTPUT(31 downto 0)=>XLXN_2(31 downto 0));
   
   REG3 : reg32
      port map (CLK=>CLK,
                INPUT(31 downto 0)=>EXP3(31 downto 0),
                LOAD=>XLXN_69,
                RESET=>RESET,
                OUTPUT(31 downto 0)=>XLXN_8(31 downto 0));
   
   sub1 : sub_fp
      port map (a(31 downto 0)=>XLXN_24(31 downto 0),
                b(31 downto 0)=>XLXN_86(31 downto 0),
                clk=>CLK,
                operation_nd=>sub_nd,
                sclr=>RESET,
                operation_rfd=>open,
                rdy=>sub1_rdy,
                result(31 downto 0)=>DIVFACTOR(31 downto 0));
   
end BEHAVIORAL;


